#  Copyright (C) 2010  Stanislav Sinyagin
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

# Stanislav Sinyagin <ssinyagin@yahoo.com>
#
#

=head1 Torrus plugin for M-net Telekommunikations

Status: Release candidate; Last modified: 7-AUG-2010

=head2 Introduction

This plugin is aiming the automation requirements at M-net Telekommunikations
(www.m-net.de).

The interface descriptions of the form "key1=val1;key2=val2;..." are
interpreted by the plugin and corresponding actions are performed.



=head2 Installation

Follow the Torrus installation guide for the main software installation.

Unpack the plugin distribution package in some directory:

  gzip -dc tp-m-net-1.X.tar.gz | tar xvf -

Then run the Torrus plugin installation utility:

  torrus install_plugin tp-m-net-1.X

No restarting is needed.

=head2 Usage

Out of the interface description string of format "key1=val1;key2=val2;..."
the following key values are interpreted:

=over 4

=item C<bw>

Indicates the interface bandwidth in bits/second.
Scale suffixes (T, G, M, K) are supported (i.e. 5G is equal to 5.0e9).
The limits are used in graph display and also for setting up
threshold monitors. The following interface parameters are set to the
correspomding numbers: C<bandwidth-limit-in>, C<bandwidth-limit-out>,
C<upper-limit>, C<mnet-bw>, C<monitor-vars>.
If the <bw> parameter is missing in the interface
description, the physical interface speed is used.

=back

Every key-and-value pair is also reflected in interface parameters
C<mnet-attr-I<KEY>>.


Discovery parameters:

=over 4

=item C<M_net::manage>

The plugin processes only hosts which have this parameter set to C<yes>.


=item C<M_net::skip-interfaces>

Comma-separated list of interface names (their correspomnding subtree names).
These interfaces are skipped from plugin processing.

=item C<M_net::nodeid-prefix-key>

Defines a key that is used for C<nodeid> prefix instead of default value
C<if//%nodeid-device%//I<InterfaceName>//>.
If the interface contains the specified key and
value, the nodeid prefix is replaced with C<KEY//VALUE//>.

=back


=head2 Selectors

The M-net selectors extend the functionality of RFC2863_IF_MIB selectors.
The selectors of the type C<M_net> act upon the device interfaces in the same
manner as the  RFC2863_IF_MIB selectors. The only difference is that the
selector attributes are the keys used in interface descriptions.

The selector attributes may have optional numeric postfix, in order to
match several attribute extpressions.

The following example sets up the monitors on all interfaces which have
C<ct=UPSTREAM> or C<ct=BB> and C<st=act>. It also illustrates
how 2 levels of threshold
monitoring can be set up for input and output bandwidth usage:

  <param name="M_net::manage" value="yes"/>
  <param name="selectors" value="mymon"/>
  <param name="mymon-selector-type" value="M_net"/>
  <param name="mymon-selector-expr"  value="{ct1},{ct2},OR,{st},AND"/>
  <param name="mymon-ct1"  value="^UPSTREAM$"/>
  <param name="mymon-ct2"  value="^BB$"/>
  <param name="mymon-st"  value="^act$"/>
  <param name="mymon-selector-actions">
     InBytesMonitor, OutBytesMonitor
  </param>
  <param name="mymon-InBytesMonitor-arg"
     value="mnet-bwoctets-1,mnet-bwoctets-2"/>
  <param name="mymon-OutBytesMonitor-arg"
     value="mnet-bwoctets-1,mnet-bwoctets-2"/>


=head2 Monitors

The M_net plugin also delivers the file F<m-net/m-net-monitors.xml>
which can be included into the configuration. The file defines
the monitors and actions and two tokensets C<warnings> and C<critical>.








Development of this plugin was sponsored by M-net Telekommunikations GmbH.

=head1 Author

Copyright (c) 2010 Stanislav Sinyagin E<lt>ssinyagin@yahoo.comE<gt>
